"use strict";

const ValidationError = require("@validatem/error");
const util = require("util");

module.exports = function (expectedValue) {
	if (expectedValue != null) {
		return function (value) {
			// TODO: Add special deep-equals handling for eg. arrays and objects?
			if (value !== expectedValue) {
				throw new ValidationError(`Must be exactly this value: ${util.inspect(expectedValue)}`);
			}
		};
	} else {
		throw new Error("Argument to `isValue` must be a non-null value");
	}
};
